#include <stdio.h>

typedef struct bloco {
	char nome[20];
	struct bloco *ant, *prox;
} no;

typedef struct {
        no *ini, *fim;
} Lista;


void criar(Lista*);
void destruir(Lista *);
void inserir(Lista*,char*,int*,int*);
void imprimir(Lista*);


int main(void) {
    int pos, erro;
    char nome[20];
    Lista L;
    
    criar(&L);
    
    printf("Digite um nome ou \'fim\' para terminar: ");
    scanf("%s",&nome);
    if (strcmp(nome,"fim")) {
        printf("Digite a posicao em que quer inserir: ");
        scanf("%d",&pos);
    }
    while (strcmp(nome,"fim")) {
          inserir(&L,nome,&pos,&erro);
          if (erro) {
             printf("Nao foi possvel inserir %s\n",nome);
             break;
          }
          printf("Digite um nome ou \'fim\' para terminar: ");
          scanf("%s",&nome);
          if (strcmp(nome,"fim")) {
             printf("Digite a posicao em que quer inserir: ");
             scanf("%d",&pos);
          }
    }
    
    printf("Os elementos da lista sao:\n");
    imprimir(&L);
    
    destruir(&L);
    system("pause");
    return 0;
}


void criar(Lista *L) {
     L->ini=NULL;
     L->fim=NULL;
}

void destruir(Lista *L) {
     no *p;
     p=L->ini;
     while (p!=NULL) {
           L->ini=L->ini->prox;
           free(p);
           p=L->ini;
     }
}

void imprimir(Lista *L) {
     no *p;
     p=L->ini;
     while (p!=NULL) {
           printf("%s\n",p->nome);
           p=p->prox;
     }
}

void inserir(Lista *L, char *x, int *pos, int *erro) {
     no *p, *aux1, *aux2;

     //cria n e coloca informao nele     
     p=(no*) malloc(sizeof(no));
     if (p==NULL)
        *erro=1;
     else {
        *erro=0;
        strcpy(p->nome,x);
        //se lista vazia
        if (L->ini==NULL) {
           L->ini=p;
           L->fim=p;
           p->ant=NULL;
           p->prox=NULL;
        }
        //se lista no vazia
        else {
           //procura onde inserir
           aux1=L->ini;
           while ((aux1!=NULL) && (*pos-1>0)) {
                 aux1=aux1->prox;
                 (*pos)--;
           }
           //se insere no incio
           if (aux1==L->ini) {
              p->ant=NULL;
              p->prox=L->ini;
              L->ini->ant=p;
              L->ini=p;
           }
           //se insere no fim
           else if (aux1==NULL) {
                p->ant=L->fim;
                p->prox=NULL;
                L->fim->prox=p;
                L->fim=p;
           }
           //se insere no meio
           else {
                aux2=aux1->ant;
                aux1->ant=p;
                p->prox=aux1;
                aux2->prox=p;
                p->ant=aux2;
           }           
        }       
     }     
}
